#pragma once

#include <cmath>
class pid_controller_t
{
  public:
    float Kp = 0;                    // Proportional gain
    float Ki = 0;                    // Integral gain
    float Kd = 0;                    // Derivative gain
    float integral_limit = INFINITY; // Limit for integral term
    float output_ramp = INFINITY;    // Limit for output derivative
    float compute(float error, float dt);
    void reset();

  private:
    float error_sum = 0;  // Running sum of errors for integral term
    float last_error = 0; // Error from previous iteration for derivative term
    float last_output = 0;
};