#include "lv_drivers_adapter.h"
#include "main.h"
#include "spi.h"
#include "stm32f4xx_hal.h"
void lvda_delay_us(unsigned long us)
{
    __IO uint32_t currentTicks = SysTick->VAL;
    /* Number of ticks per millisecond */
    const uint32_t tickPerMs = SysTick->LOAD + 1;
    /* Number of ticks to count */
    const uint32_t nbTicks = ((us - ((us > 0) ? 1 : 0)) * tickPerMs) / 1000;
    /* Number of elapsed ticks */
    uint32_t elapsedTicks = 0;
    __IO uint32_t oldTicks = currentTicks;
    do
    {
        currentTicks = SysTick->VAL;
        elapsedTicks += (oldTicks < currentTicks) ? tickPerMs + oldTicks - currentTicks : oldTicks - currentTicks;
        oldTicks = currentTicks;
    } while (nbTicks > elapsedTicks);
}

void lvda_delay_ms(unsigned long ms)
{
    HAL_Delay((uint32_t)ms);
}

void lvda_disp_cmd_data_write(int mode)
{
    HAL_GPIO_WritePin(DispDC_GPIO_Port, DispDC_Pin, mode ? GPIO_PIN_SET : GPIO_PIN_RESET);
}
void lvda_disp_rst_write(int mode)
{
    HAL_GPIO_WritePin(DispRst_GPIO_Port, DispRst_Pin, mode ? GPIO_PIN_SET : GPIO_PIN_RESET);
}
void lvda_disp_spi_cs(int mode)
{
    HAL_GPIO_WritePin(DispCS_GPIO_Port, DispCS_Pin, !mode ? GPIO_PIN_SET : GPIO_PIN_RESET);
}
void lvda_disp_spi_write_byte(uint8_t data)
{
    HAL_SPI_Transmit(&hspi1, &data, sizeof(uint8_t), HAL_MAX_DELAY);
}
void lvda_disp_spi_write_bytes(uint8_t *data, uint16_t length)
{
    HAL_SPI_Transmit(&hspi1, data, length, HAL_MAX_DELAY);
}